
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Aqua
#property indicator_color2  Red
#property indicator_color3  Blue
#property indicator_color4  Red
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  1
#property indicator_width4  1



extern int    FasterEMA       = 5;
extern int    SlowerEMA       = 12;
extern int    FasterSidusEMA  = 18;
extern int    SlowerSidusEMA  = 28;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double CrossUp[];
double CrossDn[];
double Tup[];
double Tdn[];
double trend[];

//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,CrossUp); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,241);
   SetIndexBuffer(1,CrossDn); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,242);
   SetIndexBuffer(2,Tup);     SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,167); 
   SetIndexBuffer(3,Tdn);     SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,167);
   SetIndexBuffer(4,trend);
   
return(0);
}
  
//+------------------------------------------------------------------+
//| 
//+------------------------------------------------------------------+
//
//

int deinit(){ return(0); }
  
//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//

int start() 
{
   int limit,i,counted_bars = IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
       limit = MathMin(Bars - counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for (i = limit; i >= 0 ; i--)
   {
       
      double FasterEMAnow      = iMA(NULL, 0, FasterEMA, 0, MODE_EMA, PRICE_CLOSE, i);
      double FasterEMApre      = iMA(NULL, 0, FasterEMA, 0, MODE_EMA, PRICE_CLOSE, i+1);
      double SlowerEMAnow      = iMA(NULL, 0, SlowerEMA, 0, MODE_EMA, PRICE_CLOSE, i);
      double SlowerEMApre      = iMA(NULL, 0, SlowerEMA, 0, MODE_EMA, PRICE_CLOSE, i+1);
      double fasterSidusEMAnow = iMA(NULL, 0, FasterSidusEMA, 0, MODE_EMA, PRICE_CLOSE, i);
      double fasterSidusEMApre = iMA(NULL, 0, FasterSidusEMA, 0, MODE_EMA, PRICE_CLOSE, i+1);
      double slowerSidusEMAnow = iMA(NULL, 0, SlowerSidusEMA, 0, MODE_EMA, PRICE_CLOSE, i);
      double slowerSidusEMApre = iMA(NULL, 0, SlowerSidusEMA, 0, MODE_EMA, PRICE_CLOSE, i+1);
      double RSI  = iRSI(NULL,0,21,PRICE_CLOSE,i);
      double CCI  = iCCI(NULL,0,50,PRICE_CLOSE,i);
      
      trend[i] = trend[i+1];
      if (fasterSidusEMAnow > slowerSidusEMAnow) trend[i] = 1;
      if (fasterSidusEMAnow < slowerSidusEMAnow) trend[i] =-1;
      
      //
      //
      //
      //
      //
      
      Tup[i]     = EMPTY_VALUE;
      Tdn[i]     = EMPTY_VALUE; 
      CrossUp[i] = EMPTY_VALUE;
      CrossDn[i] = EMPTY_VALUE;
      if (trend[i]>0)
      { 
        if (trend[i+1]<0) Tup[i] = Low[i] - iATR(NULL,0,20,i)/2;
        if ((((FasterEMAnow >  fasterSidusEMAnow && FasterEMAnow >  slowerSidusEMAnow)  ||
              (SlowerEMAnow >  fasterSidusEMAnow && SlowerEMAnow >  slowerSidusEMAnow)) &&
              (FasterEMApre <= fasterSidusEMApre || FasterEMApre <= slowerSidusEMApre)  &&
              (SlowerEMApre <= fasterSidusEMApre || SlowerEMApre <= slowerSidusEMApre)  &&
               RSI > 50 && CCI > 0))  CrossUp[i] = Low[i]  - iATR(NULL,0,20,i)/2;
      }
      if (trend[i]<0)
      {
        if (trend[i+1]>0) Tdn[i] = High[i] + iATR(NULL,0,20,i)/2; 
        if ((((FasterEMAnow <  fasterSidusEMAnow && FasterEMAnow <  slowerSidusEMAnow)  ||
              (SlowerEMAnow <  fasterSidusEMAnow && SlowerEMAnow <  slowerSidusEMAnow)) &&
              (FasterEMApre >= fasterSidusEMApre || FasterEMApre >= slowerSidusEMApre)  &&
              (SlowerEMApre >= fasterSidusEMApre || SlowerEMApre >= slowerSidusEMApre)  &&
               RSI < 50 && CCI < 0))  CrossDn[i] = High[i] + iATR(NULL,0,20,i)/2; 
      }
      
  }
  
  //
  //
  //
  //
  //
  
  if (alertsOn)
  {
         static datetime basicAlertedTime   = 0;
         static string   basicAlertedWhat   = "";
         static datetime reentryAlertedTime = 0;
         static string   reentryAlertedWhat = "";
         int whichBar=1;

         if (alertsOnCurrent) whichBar = 0;
         if (Tup[whichBar]     != EMPTY_VALUE) doAlert(basicAlertedWhat  ,basicAlertedTime  ,Time[0],"Signal for buy");
         if (Tdn[whichBar]     != EMPTY_VALUE) doAlert(basicAlertedWhat  ,basicAlertedTime  ,Time[0],"Signal for sell");
         if (CrossUp[whichBar] != EMPTY_VALUE) doAlert(reentryAlertedWhat,reentryAlertedTime,Time[0],"Re-entry for buy");
         if (CrossDn[whichBar] != EMPTY_VALUE) doAlert(reentryAlertedWhat,reentryAlertedTime,Time[0],"Re-entry for sell"); 
  }
return(0);
}

//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, datetime atTime, string doWhat)
{
   string message;
   if (previousAlert != doWhat || previousTime != atTime){
       previousAlert  = doWhat;
       previousTime   = atTime;

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Sidus ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(Symbol()+" Sidus ",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}